/***************************************************************

 **************************************************************/

unsigned char inb(unsigned int port) {
  unsigned char ret;
  asm volatile ("inb %%dx, %%al":"=a" (ret):"d" (port));
  return ret;
}

void outb(unsigned int port, unsigned char value) {
  asm volatile ("outb %%al, %%dx": :"d" (port), "a" (value));
}

static inline unsigned short inw(unsigned short port)
{
  unsigned short ret;
  asm volatile ( "inw %1, %0"
                 : "=a"(ret)
                 : "Nd"(port) );
  return ret;
}

static inline void outw(unsigned short port, unsigned short val)
{
  asm volatile ( "outw %0, %1" : : "a"(val), "Nd"(port) );
}
