/***************************************************************
                     _ __ __ _ _ __ ___
                    | '__/ _` | '_ ` _ \
                    | | | (_| | | | | | |
                    |_|  \__,_|_| |_| |_|
                  access to physical memory
 ***************************************************************
 **************************************************************/

void push(int);
int pop();

void ram_store() {
  long address = pop();
  long value   = pop();
  *((int*)address) = value;
}

void ram_fetch() {
  push(*((int*)pop()));
}

void ram_store_byte() {
  long address = pop();
  long value   = pop();
  *((char *)address) = (char)value;
}

void ram_fetch_byte() {
  push((long)*((char*)pop()) & 0xFF);
}

void ram() {
  switch (pop()) {
    case 0: ram_fetch_byte(); break;
    case 1: ram_store_byte(); break;
    case 2: ram_fetch(); break;
    case 3: ram_store(); break;
    default: break;
  }
}
